Subject: Re: Packet loss when txqueuelen is zero

From: Stefan Wahren <[email-masked]>
Date: Mon, 30 Jun 2014 19:08:16 +0200

Hi Eric,

Am 30.06.2014 07:49, schrieb Eric Dumazet:
> On Sun, 2014-06-29 at 15:51 +0200, Stefan Wahren wrote:
>
>> But fq_codel requires BQL in the QCA7000 network driver. Right?
>
> Not at all. 10 skb in TX ring is very small, BQL wont really help in
> this case.
>
> BQL is good for NIC with TSO support, mostly.
>

Dave Täht made the suggestion to reduce the skbs to 2. But i'm not sure 
if it's a good solution, because the SPI overhead becomes bigger.

I have another idea. The QCA has an internal tx buffer something above 
3000 bytes. So it would be helpful if the tx ring stores the estimated 
byte size of all skbs. In the case this sum is so big that skb with a 
MTU (1500 byte) won't fit into the QCA buffer, the tx queue can be stopped.

I commited my implementation [1] in the morning.

[1] - 
https://github.com/I2SE/qca7000/commit/4539475a4ce1d0f5ab6ed111df9d2a9ab5f9bcc3